DROP TABLE IF EXISTS user;
CREATE TABLE user (
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  username TEXT UNIQUE NOT NULL,
  passhash TEXT NOT NULL
);

DROP TABLE IF EXISTS ai;
CREATE TABLE ai (
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  name TEXT NOT NULL,
  input_keys TEXT NOT NULL, -- JSON
  chain TEXT NOT NULL -- JSON
);

DROP TABLE IF EXISTS knowledge;
CREATE TABLE knowledge (
  id INTEGER PRIMARY KEY AUTOINCREMENT,
  name TEXT NOT NULL,
  embeddings TEXT NOT NULL,
  chunk_size INTEGER NOT NULL,
  persist_directory TEXT NOT NULL
);

DROP TABLE IF EXISTS settings;
CREATE TABLE settings (
  user_id INTEGER NOT NULL,
  domain TEXT NOT NULL,
  name TEXT NOT NULL,
  value TEXT NOT NULL,
  FOREIGN KEY (user_id) REFERENCES user(id) ON UPDATE CASCADE ON DELETE CASCADE
);
CREATE UNIQUE INDEX settings_user_domain_name ON settings (user_id, domain, name);
